Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 489000 - x11-libs/gtk+:2 - add multilib support
Summary: x11-libs/gtk+:2 - add multilib support
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] GNOME (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Linux Gnome Desktop Team
URL:
Whiteboard:
Keywords:
Depends on: 488608 488868 488998 493172
Blocks: gx86-multilib 474910 489758 490156 498010 510182
  Show dependency tree
 
Reported: 2013-10-22 11:56 UTC by Andrew Church
Modified: 2014-05-14 13:39 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
gtk+-2.24.22.ebuild.patch (gtk+-2.24.22.ebuild.patch,3.58 KB, patch)
2013-10-22 11:56 UTC, Andrew Church
Details | Diff
gtk+-2.24.22.ebuild.patch (gtk+-2.24.22.ebuild.patch,3.87 KB, patch)
2014-02-08 00:57 UTC, Andrew Church
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Andrew Church 2013-10-22 11:56:40 UTC
Created attachment 361608 [details, diff]
gtk+-2.24.22.ebuild.patch

I'm currently running gtk+:2 built using this patch (with USE=-cups, see below) and the 32-bit GTK+ programs I have seem to work fine.

This needs net-print/cups to be multilibbed for USE=cups.

gtk+:3 has more base dependencies which still need to be multilibbed, so I don't have a patch for it yet.
Comment 1 Christoph Junghans gentoo-dev 2014-02-07 22:48:52 UTC
The only things, which depends on cups is printbackends/libprintbackend-cups.so
($ equery f gtk+:2 | grep "so$" | xargs scanelf -n | grep cups)
Is that actually needed by wine to print?
Comment 2 Andrew Church 2014-02-07 23:37:03 UTC
Huh?  Wine doesn't depend on GTK+ to begin with.  I guess acroread might need GTK+ printing stuff, though grepping the distribution for gtk_print gives nothing, so maybe not?

I'd be happy with disabling cups for non-native builds, but how would you go about it?  You can't have different USE flags for different ABIs; maybe just force-disable it in econf and ewarn "cups was disabled for non-native ABIs"?
Comment 3 Christoph Junghans gentoo-dev 2014-02-07 23:51:48 UTC
(In reply to Andrew Church from comment #2)
> Huh?  Wine doesn't depend on GTK+ to begin with.  I guess acroread might
> need GTK+ printing stuff, though grepping the distribution for gtk_print
> gives nothing, so maybe not?
> 
> I'd be happy with disabling cups for non-native builds, but how would you go
> about it?  You can't have different USE flags for different ABIs; maybe just
> force-disable it in econf and ewarn "cups was disabled for non-native ABIs"?
I guess, the same as for introspection, $(multilib_is_native_abi && use_enable cups cups auto || echo --disable-cups).
Comment 4 Andrew Church 2014-02-08 00:57:16 UTC
Created attachment 369842 [details, diff]
gtk+-2.24.22.ebuild.patch

Patch updated with --disable-cups for non-native as you suggested.  I've also changed multilib_is_native_abi to multilib_build_binaries per multilib team's guidance.  PTAL.
Comment 5 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2014-02-08 09:07:54 UTC
This looks like a bad idea to me. Diverging options just because it's faster without CUPS is not really a good idea, especially that the resulting issues will be hidden until user actually tries to print and fails.
Comment 6 Andrew Church 2014-02-08 15:00:22 UTC
That was my original concern as well, but the point was that there's a limited, well-defined set of programs depending on the non-native library and (as far as I can tell, anyway) none of them rely on GTK+ to print, so the lack of cups support will make no practical difference.
Comment 7 Alexandre Rostovtsev (RETIRED) gentoo-dev 2014-03-04 15:31:01 UTC
(In reply to Andrew Church from comment #6)
> That was my original concern as well, but the point was that there's a
> limited, well-defined set of programs depending on the non-native library
> and (as far as I can tell, anyway) none of them rely on GTK+ to print, so
> the lack of cups support will make no practical difference.

What about app-text/acroread? Does it use gtk's printing support or its own infrastructure?
Comment 8 Andrew Church 2014-03-04 16:21:28 UTC
(In reply to Alexandre Rostovtsev from comment #7)
> (In reply to Andrew Church from comment #6)
> > That was my original concern as well, but the point was that there's a
> > limited, well-defined set of programs depending on the non-native library
> > and (as far as I can tell, anyway) none of them rely on GTK+ to print, so
> > the lack of cups support will make no practical difference.
> 
> What about app-text/acroread? Does it use gtk's printing support or its own
> infrastructure?

(In reply to Andrew Church from comment #2)
> Huh?  Wine doesn't depend on GTK+ to begin with.  I guess acroread might
> need GTK+ printing stuff, though grepping the distribution for gtk_print
> gives nothing, so maybe not?
Comment 9 Steven Newbury 2014-04-29 09:08:26 UTC
I have a working ebuild in my overlay below for this; along with it's dependencies:

https://github.com/sjnewbury/gentoo-gx86-staging
Comment 10 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2014-05-14 13:39:17 UTC
Committed p.masked.